﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Controls.Charts;

namespace XamDataChartNoiseDataDemo.Views
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MultipleSignalView : Window
    {

        public ViewModels.MultipleSignalViewModel ViewModel
        {
            get
            {
                return (ViewModels.MultipleSignalViewModel)this.DataContext;
            }
        }


        public MultipleSignalView()
        {
            InitializeComponent();

            ObservableCollection<Models.CrankshaftSignal> cranks = new ObservableCollection<Models.CrankshaftSignal>();
            cranks.Add(new Models.CrankshaftSignal("Crank 1"));
            cranks.Add(new Models.CrankshaftSignal("Crank 2"));
            cranks.Add(new Models.CrankshaftSignal("Crank 3"));

            ViewModels.MultipleSignalViewModel vm = new ViewModels.MultipleSignalViewModel(cranks);
            this.DataContext = vm;


        }

        private void TreeViewCheckBox_Checked(object sender, RoutedEventArgs e)
        {
            CheckBox cb = sender as CheckBox;

            if (cb == null)
            {
                return;
            }

            if (cb.DataContext == null)
            {
                return;
            }

            if (cb.DataContext is Models.CrankshaftSignal)
            {
                Models.CrankshaftSignal sig = cb.DataContext as Models.CrankshaftSignal;
                this.ViewModel.SelectedSignals.Add(sig);
            }
        }

        private void TreeViewCheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            CheckBox cb = sender as CheckBox;

            if (cb == null)
            {
                return;
            }

            if (cb.DataContext == null)
            {
                return;
            }

            if (cb.DataContext is Models.CrankshaftSignal)
            {
                Models.CrankshaftSignal sig = cb.DataContext as Models.CrankshaftSignal;
                this.ViewModel.SelectedSignals.Remove(sig);
            }
        }


    }
  
}
