﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Controls.Charts;

namespace XamDataChartNoiseDataDemo.Views2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MultipleSignalView : Window
    {

        public ViewModels.MultipleSignalViewModel ViewModel
        {
            get
            {
                return (ViewModels.MultipleSignalViewModel)this.DataContext;
            }
        }


        public MultipleSignalView()
        {
            InitializeComponent();

            ObservableCollection<Models.CrankshaftSignal> cranks = new ObservableCollection<Models.CrankshaftSignal>();
            cranks.Add(new Models.CrankshaftSignal("Crank 1"));
            cranks.Add(new Models.CrankshaftSignal("Crank 2"));
            cranks.Add(new Models.CrankshaftSignal("Crank 3"));

            ViewModels.MultipleSignalViewModel vm = new ViewModels.MultipleSignalViewModel(cranks);
            this.DataContext = vm;


        }

        private void TreeViewCheckBox_Checked(object sender, RoutedEventArgs e)
        {
            CheckBox cb = sender as CheckBox;

            if (cb == null)
            {
                return;
            }

            if (cb.DataContext == null)
            {
                return;
            }

            if (cb.DataContext is Models.CrankshaftSignal)
            {
                Models.CrankshaftSignal sig = cb.DataContext as Models.CrankshaftSignal;
                this.ViewModel.SelectedSignals.Add(sig);
            }
        }

        private void TreeViewCheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            CheckBox cb = sender as CheckBox;

            if (cb == null)
            {
                return;
            }

            if (cb.DataContext == null)
            {
                return;
            }

            if (cb.DataContext is Models.CrankshaftSignal)
            {
                Models.CrankshaftSignal sig = cb.DataContext as Models.CrankshaftSignal;
                this.ViewModel.SelectedSignals.Remove(sig);
            }
        }


        private void Legend_Drop(object sender, Infragistics.DragDrop.DropEventArgs e)
        {

            // get legend
            Infragistics.Controls.Charts.Legend legend = e.DragSource as Infragistics.Controls.Charts.Legend;

            if (legend == null)
            {
                return;
            }


            // get mouse pointer position relative to chart
            Point p = e.GetPosition(this.chartMultipleSignals);


            // left
            if (System.Math.Abs(p.X) < System.Math.Abs(this.chartMultipleSignals.ActualWidth / 2 - p.X))
            {

                // top
                if (System.Math.Abs(p.Y) < System.Math.Abs(this.chartMultipleSignals.ActualHeight / 2 - p.Y))
                {
                    this.ViewModel.LegendDockEdge = Infragistics.Controls.DockEdge.InsideTop;
                    this.ViewModel.LegendVerticalDockAlignment = System.Windows.VerticalAlignment.Top;
                    this.ViewModel.LegendHorizontalDockAlignment = System.Windows.HorizontalAlignment.Left;
                }


                // middle
                else if (System.Math.Abs(p.Y - this.chartMultipleSignals.ActualHeight / 2) < System.Math.Abs(this.chartMultipleSignals.ActualHeight - p.Y))
                {
                    this.ViewModel.LegendDockEdge = Infragistics.Controls.DockEdge.InsideLeft;
                    this.ViewModel.LegendVerticalDockAlignment = System.Windows.VerticalAlignment.Center;
                    this.ViewModel.LegendHorizontalDockAlignment = System.Windows.HorizontalAlignment.Center;
                }


                // bottom
                else
                {
                    this.ViewModel.LegendDockEdge = Infragistics.Controls.DockEdge.InsideBottom;
                    this.ViewModel.LegendVerticalDockAlignment = System.Windows.VerticalAlignment.Top;
                    this.ViewModel.LegendHorizontalDockAlignment = System.Windows.HorizontalAlignment.Left;
                }

            }


            // center
            else if (p.X - System.Math.Abs(this.chartMultipleSignals.ActualWidth / 2) < System.Math.Abs(this.chartMultipleSignals.ActualWidth - p.X))
            {

                // top
                if (System.Math.Abs(p.Y) < System.Math.Abs(this.chartMultipleSignals.ActualHeight / 2 - p.Y))
                {
                    this.ViewModel.LegendDockEdge = Infragistics.Controls.DockEdge.InsideTop;
                    this.ViewModel.LegendVerticalDockAlignment = System.Windows.VerticalAlignment.Top;
                    this.ViewModel.LegendHorizontalDockAlignment = System.Windows.HorizontalAlignment.Center;
                }


                // middle
                else if (System.Math.Abs(p.Y - this.chartMultipleSignals.ActualHeight / 2) < System.Math.Abs(this.chartMultipleSignals.ActualHeight - p.Y))
                {
                    //this.ViewModel.LegendDockEdge = Infragistics.Controls.DockEdge.Central;
                    //this.ViewModel.LegendVerticalDockAlignment = System.Windows.VerticalAlignment.Center;
                    //this.ViewModel.LegendHorizontalDockAlignment = System.Windows.HorizontalAlignment.Center;
                }


                // bottom
                else
                {
                    this.ViewModel.LegendDockEdge = Infragistics.Controls.DockEdge.InsideBottom;
                    this.ViewModel.LegendVerticalDockAlignment = System.Windows.VerticalAlignment.Top;
                    this.ViewModel.LegendHorizontalDockAlignment = System.Windows.HorizontalAlignment.Center;
                }

            }


            // right
            else
            {

                // top
                if (System.Math.Abs(p.Y) < System.Math.Abs(this.chartMultipleSignals.ActualHeight / 2 - p.Y))
                {
                    this.ViewModel.LegendDockEdge = Infragistics.Controls.DockEdge.InsideTop;
                    this.ViewModel.LegendVerticalDockAlignment = System.Windows.VerticalAlignment.Top;
                    this.ViewModel.LegendHorizontalDockAlignment = System.Windows.HorizontalAlignment.Right;
                }


                // middle
                else if (System.Math.Abs(p.Y - this.chartMultipleSignals.ActualHeight / 2) < System.Math.Abs(this.chartMultipleSignals.ActualHeight - p.Y))
                {
                    this.ViewModel.LegendDockEdge = Infragistics.Controls.DockEdge.InsideRight;
                    this.ViewModel.LegendVerticalDockAlignment = System.Windows.VerticalAlignment.Center;
                    this.ViewModel.LegendHorizontalDockAlignment = System.Windows.HorizontalAlignment.Center;
                }


                // bottom
                else
                {
                    this.ViewModel.LegendDockEdge = Infragistics.Controls.DockEdge.InsideBottom;
                    this.ViewModel.LegendVerticalDockAlignment = System.Windows.VerticalAlignment.Top;
                    this.ViewModel.LegendHorizontalDockAlignment = System.Windows.HorizontalAlignment.Right;
                }

            }

        }
    }
  
}
